VERSION 5.00
Begin VB.UserControl WroxCrypto 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "WroxCrypto.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "WroxCrypto.ctx":0014
End
Attribute VB_Name = "WroxCrypto"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

  'Events
  Event KeyChanged()
  Event Encrypted(strEncryptedText As String)
  Event Decrypted(strDecryptedText As String)
  
    'Private Member variables
  Private mintKeyLen As Integer
  Private mstrKey As String
  Private mstrMessage As String
  Private mstrEncryption As String

  'Default value for the Key property
  Const strDefaultKey = "Hello"

Public Property Let Key(strValue As String)

  'Test to see if its is 5 charaters of more
  If Len(strValue) < 5 Then

     'If it is raise an error
     Err.Raise vbObjectError + 1001, "WroxCrypto", "Key must be 5 characters or more"

  End If

  'Set private member variables
  mstrKey = strValue
  mintKeyLen = Len(mstrKey)
  PropertyChanged "Key"
  RaiseEvent KeyChanged

End Property

Public Property Get Key() As String
Attribute Key.VB_ProcData.VB_Invoke_Property = "ppgProperties"

  Key = mstrKey

End Property

Public Property Let Message(strValue As String)

  mstrMessage = strValue

End Property

Public Property Get Message() As String
Attribute Message.VB_ProcData.VB_Invoke_Property = "ppgProperties"

  Message = mstrMessage

End Property
Public Property Let Encryption(strValue As String)

  mstrEncryption = strValue

End Property

Public Property Get Encryption() As String
Attribute Encryption.VB_ProcData.VB_Invoke_Property = "ppgProperties"

  Encryption = mstrEncryption

End Property

Public Function Encrypt() As String

  mstrEncryption = Algorithm(mstrMessage)
  Encrypt = mstrEncryption
  RaiseEvent Encrypted(mstrEncryption)

End Function

Public Function Decrypt() As String

  mstrMessage = Algorithm(mstrEncryption)
  Decrypt = mstrMessage
  RaiseEvent Decrypted(mstrMessage)

End Function

Private Function Algorithm(ByVal strText As String) As String

    Dim intTextLen As Integer
    Dim intSections As Integer
    Dim intStartPos As Integer
    Dim intCountSections As Integer
    Dim intOffset As Integer
    Dim strWorking As String
    
    intTextLen = Len(strText)
    
    'Calculate the number of sections in the message string
    intSections = intTextLen / mintKeyLen
    
    'Add another section if it doesn't divide neatly
    If intTextLen Mod mintKeyLen Then
                
        intSections = intSections + 1
    
    End If
    
    intStartPos = 1
    intCountSections = 0

    Do Until intCountSections = intSections
        'Test for even numbered section
        If intCountSections Mod 2 <> 0 Then
            strWorking = strWorking & Mid$(strText, intStartPos, mintKeyLen)
        
        Else
            'Reverse the string's characters
            strWorking = strWorking & StrReverse(Mid$(strText, intStartPos, mintKeyLen))

        End If

        'Increase the counter variables
        intStartPos = intStartPos + mintKeyLen
        intCountSections = intCountSections + 1
    Loop
    
    'Set the return value of the function
    Algorithm = strWorking

End Function

Private Sub UserControl_InitProperties()

  Key = strDefaultKey

End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

  Key = PropBag.ReadProperty("Key", strDefaultKey)

End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

  PropBag.WriteProperty "Key", Key, strDefaultKey

End Sub
Private Sub UserControl_Resize()

  'Set the control's dimensions to this if the user tries to resize it
  UserControl.Height = 600
  UserControl.Width = 600

End Sub
Public Sub About()
Attribute About.VB_UserMemId = -552
  
  'Load the About form as Modal
  frmAbout.Show vbModal

End Sub

