VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Payment"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_lngPaymentNumber As Long
Private m_curPayment As Currency
Private m_curPrincipal As Currency
Private m_curInterest As Currency
Private m_curBalance As Currency

' the PaymentNumber property indicates the number of
' the payment for which this objects specifies the details
Public Property Get PaymentNumber() As Long
    PaymentNumber = m_lngPaymentNumber
End Property

Friend Property Let PaymentNumber(lngPaymentNum As Long)
    m_lngPaymentNumber = lngPaymentNum
End Property

' the PaymentAmount property is the periodic payment due
' for the loan - each payment object will have the same value
Public Property Get PaymentAmount() As Currency
    PaymentAmount = m_curPayment
End Property

Friend Property Let PaymentAmount(curPayment As Currency)
    m_curPayment = curPayment
End Property

' the Principal property is the amount that the loan balance
' is reduced by after this payment
Public Property Get Principal() As Currency
    Principal = m_curPrincipal
End Property

Friend Property Let Principal(curPrincipal As Currency)
    m_curPrincipal = curPrincipal
End Property

' the Interest property is the amount of the payment that
' is applied to the cost of the loan
Public Property Get Interest() As Currency
    Interest = m_curInterest
End Property

Friend Property Let Interest(curInterest As Currency)
    m_curInterest = curInterest
End Property

' the RemainingBalance property indicates the principal
' amount left on the loan after this payment
Public Property Get RemainingBalance() As Currency
    RemainingBalance = m_curBalance
End Property

Friend Property Let RemainingBalance(curBalance As Currency)
    m_curBalance = curBalance
End Property


