VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Payout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_lngPayoutNumber As Long
Private m_curPayout As Currency
Private m_curEarnings As Currency
Private m_curReturn As Currency
Private m_curBalance As Currency

' Create class event handlers
' N/A

' Create the properties for our class
'
' in this class all of our properties will have public
' read access, but only friend write access

' the PayoutNumber property indicates the number of
' the payout for which this objects specifies the details
Public Property Get PayoutNumber() As Long
    PayoutNumber = m_lngPayoutNumber
End Property

Friend Property Let PayoutNumber(lngPayoutNum As Long)
    m_lngPayoutNumber = lngPayoutNum
End Property

' the PayoutAmount property is the periodic payout to be
' received - each payout object will have the same value
Public Property Get PayoutAmount() As Currency
    PayoutAmount = m_curPayout
End Property

Friend Property Let PayoutAmount(curPayout As Currency)
    m_curPayout = curPayout
End Property

' the EarningsForPeriod property is the amount of earnings
' that the annuity had for the period
Public Property Get EarningsForPeriod() As Currency
    EarningsForPeriod = m_curEarnings
End Property

Friend Property Let EarningsForPeriod(curEarnings As Currency)
    m_curEarnings = curEarnings
End Property

' the ReturnOfCapital property is the amount or the payout
' that reduces the balance of the annuity
Public Property Get ReturnOfCapital() As Currency
    ReturnOfCapital = m_curReturn
End Property

Friend Property Let ReturnOfCapital(curReturn As Currency)
    m_curReturn = curReturn
End Property

' the RemainingBalance property indicates the principal
' amount left in the annuity after this payout
Public Property Get RemainingBalance() As Currency
    RemainingBalance = m_curBalance
End Property

Friend Property Let RemainingBalance(curBalance As Currency)
    m_curBalance = curBalance
End Property

' Create the methods for our class
' N/A

' Create the supporting procedures
' N/A

