VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTitles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' clsTitles - wraps up the Biblio Titles table. By keeping the
' interface consistent it should be possible to move the class
' or point at some other data source, such as an RDO Resultset,
' or flat file, without users of the class ever noticing.

Implements clsRecordset

Public Event DataChanged()

'Public members to implement properties
Public strTitle As String
Public intYear_Published As Integer
Public strISBN As String
Public lngPubID As Long
Public strDescription As String
Public strNotes As String
Public strSubject As String
Public strComments As String

' Private members to hold connection to database,
' and to the recordset itself

Private m_recTitles As Recordset
Private m_dbDatabase As Database

' Class event handlers

Private Sub Class_Initialize()
' When an instance of a class is created, we want to
' connect to the database and open up the Titles table.

    On Error GoTo Class_Initialize_Error
    
    Set m_dbDatabase = Workspaces(0).OpenDatabase _
    (App.Path & "\Biblio.mdb")
    Set m_recTitles = m_dbDatabase.OpenRecordset("Titles", _
    dbOpenTable)
    
    Exit Sub
    
Class_Initialize_Error:
    MsgBox "There was a problem opening either the Biblio " & _
    "database, or the Titles table.", vbExclamation, "Problem"
    Exit Sub

End Sub

Private Sub Class_Terminate()
' When the instance of the class is destroyed, we need to
' close down the recordset, and also the connection to the
' database. Error handling is needed since there could have
' been a problem in the Initialize routine making these
' connections invalid

On Error Resume Next

m_recTitles.Close
m_dbDatabase.Close

End Sub

' Generic Data management methods

Private Sub Reload_Members()
' Reloads the member variables (properties) with the field
' values of the current record

On Error GoTo Reload_Members_Error

With m_recTitles
    
    strTitle = "" & .Fields("title")
    intYear_Published = .Fields("Year Published")
    strISBN = "" & .Fields("ISBN")
    lngPubID = .Fields("PubID")
    strDescription = "" & .Fields("description")
    strNotes = "" & .Fields("Notes")
    strSubject = "" & .Fields("subject")
    strComments = "" & .Fields("Comments")
    
End With

RaiseEvent DataChanged

Exit Sub

Reload_Members_Error:
    Exit Sub
    
End Sub

Public Sub clsRecordset_AddAsNew()
' Do nothing
End Sub

Public Sub clsRecordset_DeleteCurrent()
' Do nothing
End Sub

'Class methods

Public Sub clsRecordset_MoveNext()
    If Not m_recTitles.EOF Then
        m_recTitles.MoveNext
        Reload_Members
    End If
    
End Sub

Public Sub clsRecordset_MovePrevious()
    If Not m_recTitles.BOF Then
        m_recTitles.MovePrevious
        Reload_Members
    End If
    
End Sub

Public Sub clsRecordset_MoveLast()
    m_recTitles.MoveLast
    Reload_Members
End Sub

Public Sub clsRecordset_MoveFirst()
    m_recTitles.MoveFirst
    Reload_Members
End Sub

Public Sub clsRecordset_SaveChanges()
' Do nothing
End Sub
