VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "SalesOrderT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3748FC6100DE"
'The transact data centric SalesOrder class.
Option Explicit

Implements MTxAS.ObjectControl

'##ModelId=374C45110058
Private Const mcClassName As String = "DCSalesOrder.SalesOrderT"
'##ModelId=374C451100D0
Private Const mcObjectError As Long = vbObjectError + &H1040

'##ModelId=374C4511015C
Private mObjCtx As MTxAS.ObjectContext
'##ModelId=3748FCE60338
Private mItemT As DCSalesOrder.SalesOrderItemT

'Save a sales order record and returns the order ID.  It uses SalesOrderItemT
'to save its items.
'##ModelId=374904160059
Public Function Save(ByVal OrderData As String) As Long
    On Error GoTo ErrHandler
    
    Dim cn As adodb.Connection
    Dim cmd As adodb.Command
    
    Dim SQLQuery As String
    Dim OrderID As Long
    Dim CustomerID As String
    Dim Items As Collection
    Dim ItemIndex As Integer
    Dim ItemData As String
    
    Set Items = New Collection
    Deserialize OrderData, CustomerID, Items
    
    ' Create header
    Set cn = New adodb.Connection
    cn.Open ConnString
    
    Set cmd = New adodb.Command
    With cmd
        Set .ActiveConnection = cn
        .CommandType = adCmdStoredProc
        .CommandText = "spAddOrder"
        .Parameters.Append .CreateParameter("OrderID", adInteger, adParamReturnValue, 4)
        .Parameters.Append .CreateParameter("CustomerID", adChar, adParamInput, 5, CustomerID)
        .Execute
    End With
    OrderID = cmd("OrderID").Value
    
    ' Create lines
    For ItemIndex = 1 To Items.Count
        ItemData = Items.Item(ItemIndex)
        mItemT.Save OrderID, ItemData
    Next ItemIndex
    
    Save = OrderID
    mObjCtx.SetComplete
    
FuncExit:
    On Error Resume Next
    Set Items = Nothing
    Set cmd = Nothing
    cn.Close
    Exit Function
    
ErrHandler:
    Err.Raise mcObjectError + 2, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Function

'Delete a Sales Order record.  It uses SalesOrderItemT to delete all items
'associated with the order.
'##ModelId=374907600186
Public Sub Delete(ByVal OrderID As Long)
    On Error GoTo ErrHandler
    
    Dim cn As adodb.Connection
    Dim SQLQuery As String
    
    mItemT.Delete OrderID
        
    SQLQuery = "DELETE Orders WHERE OrderID = " & OrderID
                
    Set cn = New adodb.Connection
    With cn
        .Open ConnString
        .Execute SQLQuery, , adExecuteNoRecords
        .Close
    End With
    
    mObjCtx.SetComplete
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError + 2, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Sub

'Deserialize the Sales Order data sent to the Save method.  The Sales Order
'data is returned with the three ByRef parameters: ID, CustomerID, and Items.
'##ModelId=37490F6003D9
Private Sub Deserialize(Data As String, CustomerID As String, Items As Collection)
    On Error GoTo ErrHandler
    
    Dim PropBag As PropertyBag
    Dim ByteArr() As Byte
    Dim ItemCount As Integer
    Dim ItemIndex As Integer
    
    ByteArr = Data
    Set PropBag = New PropertyBag
    With PropBag
        .Contents = ByteArr
        CustomerID = .ReadProperty("CustomerID")
        
        ItemCount = .ReadProperty("ItemCount")
        For ItemIndex = 1 To ItemCount
            Items.Add .ReadProperty("Item" & CStr(ItemIndex))
        Next ItemIndex
    End With
    
FuncExit:
    Set PropBag = Nothing
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError + 11, mcClassName, Err.Description
    mObjCtx.SetAbort
    Resume FuncExit
End Sub

'##ModelId=374C451200C7
Private Sub ObjectControl_Activate()
    On Error GoTo ErrHandler
    Set mObjCtx = MTxAS.GetObjectContext
    Set mItemT = mObjCtx.CreateInstance("DCSalesOrder.SalesOrderItemT")
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError, mcClassName, Err.Description
    Resume FuncExit
End Sub

'##ModelId=374C45120122
Private Function ObjectControl_CanBePooled() As Boolean
    On Error Resume Next
    ObjectControl_CanBePooled = False
End Function

'##ModelId=374C45120186
Private Sub ObjectControl_Deactivate()
    On Error Resume Next
    Set mItemT = Nothing
    Set mObjCtx = Nothing
End Sub

