VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Product"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"37488CBF0103"
'The UI centric Product class.  It uses the data centric ProductN (non-transact)
'and ProductT (transact) classes to perform database access.

Option Explicit

'##ModelId=374C45C702E5
Private Const mcClassName As String = "UIObjects.Product"
'##ModelId=374C45C7037B
Private Const mcObjectError As String = vbObjectError + &H1110

'##ModelId=374C45C80029
Private mID As Long
Private mName As String
Private mPrice As Currency

Private mProductN As DCProduct.ProductN

'ADDED BY CAB
Private mrecProducts As ADODB.Recordset

'Retrieve the ID of a product.  It is automatically assigned by the database
'when a new product is added to the database.  It is a read-only property.
Public Property Get ID() As Long
    Let ID = mID
End Property

'Retrieve product name.
Public Property Get Name() As String
    Let Name = mName
End Property

'Retrieve the product price.
Public Property Get Price() As Currency
    Let Price = mPrice
End Property

Public Sub Read(Optional ID As Long = 0)
    On Error GoTo ErrHandler
    
    Dim rs As ADODB.Recordset
    Set rs = mProductN.GetByID(ID)
    Populate rs
    
    'ADDED BY CAB
    If mrecProducts Is Nothing Then
      Set mrecProducts = rs.Clone(adLockReadOnly)
    End If

FuncExit:
    On Error Resume Next
    If Not rs Is Nothing Then
        If rs.State = adStateOpen Then
            rs.Close
        End If
        Set rs = Nothing
    End If
    Exit Sub
    
ErrHandler:
    Err.Raise vbObjectError + 1, mcClassName, Err.Description
    Resume FuncExit
End Sub

Private Sub Populate(ProductRS As ADODB.Recordset)
    On Error GoTo ErrHandler
    
    With ProductRS
        If Not (.BOF And .EOF) Then
            mID = .Fields("ProductID").Value
            mName = .Fields("ProductName").Value
            mPrice = .Fields("UnitPrice").Value
        End If
    End With
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise vbObjectError + 11, mcClassName, Err.Description
    Resume FuncExit
End Sub

Private Sub Class_Initialize()
    On Error GoTo ErrHandler
    Set mProductN = CreateObject("DCProduct.ProductN")
    
FuncExit:
    Exit Sub
    
ErrHandler:
    Err.Raise mcObjectError, mcClassName, Err.Description
    Resume FuncExit
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    Set mProductN = Nothing
End Sub

'ADDED BY CAB
Public Property Get ProductList() As ADODB.Recordset

  Set ProductList = mrecProducts

End Property

