VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "clsMTSTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
    
Implements ObjectControl

Private mobjADOConnection As ADODB.Connection
Private mobjContext As ObjectContext

Public Enum eErrorLevels
  Informational = 4
  Warning = 2
  Error = 1
End Enum

Private Const mcstrDatabasePath As String = "C:\Wrox\Code\Chapter09\Log.mdb"
Private Const mcstrDateField As String = "DateLogged"
Private Const mcstrMessageField As String = "Message"
Private Const mcstrLevelField As String = "Level"
Private Const mcstrMethodPropertyField As String = "MethodProperty"
Private Const mcstrClassField As String = "Class"
Private Const mcstrApplicationField As String = "Application"

'''Private Const mcstrDatabasePath As String = "C:\Program Files\Microsoft Visual Studio\VB98\NWind.mdb"
                                            
Private Sub ObjectControl_Activate()

  Set mobjContext = GetObjectContext

End Sub

Private Function ObjectControl_CanBePooled() As Boolean

  ObjectControl_CanBePooled = False

End Function

Private Sub ObjectControl_Deactivate()

  Set mobjADOConnection = Nothing
  Set mobjContext = Nothing

End Sub

Private Function CreateInstance(ProgID As String) As Object

  On Error GoTo CreateInstanceError

  If Not mobjContext Is Nothing Then
    Set CreateInstance = mobjContext.CreateInstance(ProgID)
  Else
    WriteToEventLog App.EXEName, "LogFile", "CreateInstance", _
                    "Can not get reference to Context", Warning

    Select Case ProgID

      Case "ADODB.Connection"
          Set CreateInstance = New ADODB.Connection

      Case "ADODB.Recordset"
          Set CreateInstance = New ADODB.Recordset

    End Select

  End If

  Exit Function

CreateInstanceError:

  Err.Raise Err.Number, Err.Source & " CreateInstance", Err.Description

End Function

Private Sub SetADOConnection(ByVal v_strUserID As String, _
                             ByVal v_strPassword As String, _
                             Optional ByVal v_strConnectionString As String _
                                      = "Empty")
  
  On Error GoTo SetADOConnectionError

  Set mobjADOConnection = CreateInstance("ADODB.Connection")

  With mobjADOConnection
     .CursorLocation = adUseServer
     If v_strConnectionString = "Empty" Then
         .ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                             "Persist Security Info=False;" & _
                             "Data Source=" & mcstrDatabasePath

     Else
         .ConnectionString = v_strConnectionString
     End If

     .Open
  End With
   
  Exit Sub

SetADOConnectionError:

  Dim lngErrorCounter As Long
  Dim strErrors As String

  strErrors = Err.Number & ": " & Err.Description

  If mobjADOConnection.Errors.Count > 0 Then

     For lngErrorCounter = 0 To mobjADOConnection.Errors.Count - 1
        strErrors = strErrors & _
        mobjADOConnection.Errors(lngErrorCounter).Number & _
        ": " & mobjADOConnection.Errors(lngErrorCounter).Description & _
        vbCrLf
     Next lngErrorCounter

  End If

  Err.Raise Err.Number, "SetADOConnection", strErrors
  WriteToTextFile App.EXEName, "LogFile", "SetADOConnection", _
                  "Connection Failed", Informational


End Sub

Private Function GetADOConnection() As ADODB.Connection

  If mobjADOConnection Is Nothing Then
     Err.Raise 2001, "GetADOConnection", _
        "Trying to Get Connection prior to setting it"
  Else
     Set GetADOConnection = mobjADOConnection

  End If

End Function

Private Sub CloseADOConnection()

  With GetADOConnection
    If .State = adStateOpen Then
       .Close
    End If

  End With
  
End Sub

Public Function GetRecordset() As ADODB.Recordset

  Dim strADOConnection As String
  Dim recCustomers As ADODB.Recordset

  On Error GoTo GetRecordsetError

  strADOConnection = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                     "Data Source=C:\Program Files\Microsoft Visual " & _
                     "Studio\VB98\Nwind.mdb;Persist Security Info=False"

  SetADOConnection "", "", strADOConnection
  Set recCustomers = New ADODB.Recordset
  recCustomers.CursorLocation = adUseClient
  recCustomers.CursorType = adOpenStatic
  recCustomers.LockType = adLockPessimistic
  recCustomers.Source = "Customers"
  Set recCustomers.ActiveConnection = GetADOConnection

  recCustomers.Open
  Set recCustomers.ActiveConnection = Nothing

  Set GetRecordset = recCustomers
     
  CloseADOConnection
  Exit Function

GetRecordsetError:

  CloseADOConnection
  Err.Raise Err.Number, Err.Source & " GetRecordset", Err.Description

End Function

Public Sub ChangeRecordset(ByVal v_recCustomer As ADODB.Recordset)

  v_recCustomer.Fields("ContactTitle") = "NewValue"

End Sub

Public Function WriteToDatabase(ByVal v_strAppName As String, _
                                ByVal v_strClass As String, _
                                ByVal v_strMethodProperty As String, _
                                ByVal v_strMessage As String, _
                                ByVal v_eLevel As eErrorLevels) As String

  Dim recLog As ADODB.Recordset

  On Error GoTo WriteToDatabaseError

  SetADOConnection "", ""
  
  Set recLog = New ADODB.Recordset
  recLog.CursorLocation = adUseServer
  recLog.CursorType = adOpenDynamic
  recLog.LockType = adLockPessimistic

  If v_eLevel = Informational Then
    recLog.Source = "ApplicationLog"
  Else
    recLog.Source = "ErrorLog"
  End If

  Set recLog.ActiveConnection = GetADOConnection
  recLog.Open
  recLog.AddNew

  recLog.Fields(mcstrApplicationField) = v_strAppName
  recLog.Fields(mcstrClassField) = v_strClass
  recLog.Fields(mcstrDateField) = Now
  recLog.Fields(mcstrLevelField) = v_eLevel
  recLog.Fields(mcstrMessageField) = v_strMessage
  recLog.Fields(mcstrMethodPropertyField) = v_strMethodProperty

  recLog.Update

ExitWriteToDatabase:

  CloseADOConnection
  Exit Function

WriteToDatabaseError:

  WriteToDatabase = "Error Description: " & Err.Description & vbCrLf & _
                    "Error Number: " & Err.Number & vbCrLf & _
                    "Error Source: " & Err.Source


  Err.Clear
  GoTo ExitWriteToDatabase

End Function

Public Function WriteToTextFile(ByVal v_strAppName As String, _
                                ByVal v_strClass As String, _
                                ByVal v_strMethodProperty As String, _
                                ByVal v_strMessage As String, _
                                ByVal v_eLevel As eErrorLevels) As String


  Dim intFileNumber As Integer
  Dim strAppName As String * 15
  Dim strClass As String * 15
  Dim strMethodProperty As String * 15
  Dim strMessage As String * 100
  Dim strLevel As String * 5

  strLevel = v_eLevel
  strAppName = v_strAppName
  strClass = v_strClass
  strMethodProperty = v_strMethodProperty
  strMessage = v_strMessage

  intFileNumber = FreeFile
  If v_eLevel = Informational Then
    Open "C:\" & v_strAppName & "Log.txt" For Append As #intFileNumber
    Write #intFileNumber, intFileNumber & Chr(34) & _
                          strAppName & Chr(34) & _
                          strClass & Chr(34) & _
                          strMethodProperty & Chr(34) & _
                          strMessage
  Else
    strLevel = Str(v_eLevel)
    Open "C:\" & v_strAppName & "ErrLog.txt" For Append As #intFileNumber
    Write #intFileNumber, intFileNumber & Chr(34) & _
                          strAppName & Chr(34) & _
                          strClass & Chr(34) & _
                          strMethodProperty & Chr(34) & _
                          strMessage & Chr(34) & _
                          strLevel
  End If

  Close #intFileNumber

End Function

Public Function WriteToEventLog(ByVal v_strAppName As String, _
                                ByVal v_strClass As String, _
                                ByVal v_strMethodProperty As String, _
                                ByVal v_strMessage As String, _
                                ByVal v_eLevel As eErrorLevels) As String


  If App.LogMode = vbLogAuto Or vbLogToNT Then
     App.Title = v_strAppName
     App.LogEvent v_strMessage & "(" & v_strClass & "/" & v_strAppName & ")", _
                  v_eLevel
  Else
     If WriteToDatabase(v_strAppName, v_strClass, v_strMethodProperty, _
                        v_strMessage, v_eLevel) <> "" Then
        WriteToTextFile v_strAppName, v_strClass, v_strMethodProperty, _
                        v_strMessage, v_eLevel
     End If
  End If

End Function


