VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "LogFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
   
Private m_objADOConnection As ADODB.Connection
Private m_objContext As ObjectContext
Private Const m_cstrDatabasePath As String = "C:\Program Files\Microsoft Visual Studio\VB98\Nwind.mdb"
Implements ObjectControl

Private Sub ObjectControl_Activate()
   Set m_objContext = GetObjectContext
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
   ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
   Set m_objADOConnection = Nothing
   Set m_objContext = Nothing
End Sub

   Private Function CreateInstance(ProgID As String) As Object
   On Error GoTo CreateInstanceError
   If Not m_objContext Is Nothing Then
     Set CreateInstance = m_objContext.CreateInstance(ProgID)
   Else
     Select Case ProgID
        Case "ADODB.Connection"
           Set CreateInstance = New ADODB.Connection
        Case "ADODB.Recordset"
           Set CreateInstance = New ADODB.Recordset
   End Select
   End If

   Exit Function

CreateInstanceError:

      Err.Raise Err.Number, Err.Source & " CreateInstance", Err.Description
   End Function

   Private Sub SetADOConnection(ByVal v_strUserID As String, _
     ByVal v_strPassword As String, Optional ByVal _
     v_sConnectionString As String = "Empty")
  On Error GoTo SetADOConnectionError
  
    Set m_objADOConnection = CreateInstance("ADODB.Connection")
    
       With m_objADOConnection
     .CursorLocation = adUseServer
     If v_sConnectionString = "Empty" Then
        .ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Persist Security Info=False;Data Source=" & _
             m_cstrDatabasePath
   Else
         .ConnectionString = v_sConnectionString
   End If
        .Open
   End With

   Exit Sub
SetADOConnectionError:

     Dim lngErrorCounter As Long
     Dim strErrors As String

     strErrors = Err.Number & ": " & Err.Description

     If m_objADOConnection.Errors.Count > 0 Then

       For lngErrorCounter = 0 To m_objADOConnection.Errors.Count - 1
         strErrors = strErrors & _
         m_objADOConnection.Errors(lngErrorCounter).Number & _
         ": " & m_objADOConnection.Errors(lngErrorCounter).Description & _
         vbCrLf
       Next lngErrorCounter

     End If
     Err.Raise Err.Number, "SetADOConnection", strErrors
   End Sub
   
   Private Function GetADOConnection() As ADODB.Connection
     If m_objADOConnection Is Nothing Then
       Err.Raise 2001, "GetADOConnection", _
         "Trying to Get Connection prior to setting it"
     Else
        Set GetADOConnection = m_objADOConnection

      End If
   End Function
   
   Private Sub CloseADOConnection()
     With GetADOConnection
       If .State = adStateOpen Then
          .Close
     End If

     End With
   End Sub

   Public Function GetRecordset() As ADODB.Recordset
   
      Dim strADOConnection As String
   Dim objCustomersRS As ADODB.Recordset
   On Error GoTo GetRecordsetError

     strADOConnection = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
         "Data Source=" & m_cstrDatabasePath & _
         ";Persist Security Info=False"
   SetADOConnection "", "", strADOConnection
   Set objCustomersRS = New ADODB.Recordset
   objCustomersRS.CursorLocation = adUseClient
   objCustomersRS.CursorType = adOpenStatic
   objCustomersRS.LockType = adLockPessimistic
   objCustomersRS.Source = "Customers"
   Set objCustomersRS.ActiveConnection = GetADOConnection
   objCustomersRS.Open
   Set objCustomersRS.ActiveConnection = Nothing
   Set GetRecordset = objCustomersRS
 
   CloseADOConnection
   Exit Function
GetRecordsetError:
      CloseADOConnection
      Err.Raise Err.Number, Err.Source & " GetRecordset", Err.Description
   End Function

   Public Sub ChangeRecordset(ByVal v_oCustomerRS As ADODB.Recordset)
      v_oCustomerRS.Fields("ContactTitle") = "NewValue"
   End Sub

